﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Osoba
{
    public partial class Form1 : Form
    {
        List<Osoba> osoby;
        public Form1()
        {
            osoby = new List<Osoba>();
            InitializeComponent();
            
        }

        private void btnOpenCSV_Click(object sender, EventArgs e)
        {
            //openFileDialog1.InitialDirectory = Application.ExecutablePath;
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string file = openFileDialog1.FileName;
                tbFile.Text = file;
                var Lines = File.ReadLines(file);                               
                //var Lines = File.ReadLines(file).Select(a => a.Split(';')); // mozna i tak bez ponizszej linii
                var CSV = from line in Lines select (line.Split(';')).ToArray();
                
                osoby.Clear();
                foreach (var dane in CSV)
                {
                    osoby.Add(new Osoba(dane));
                }
                MessageBox.Show("Usuń przetwarzanie pierwszej linii z nagłówkami");
                //dataGridView1.AutoGenerateColumns = true;
                dataGridView1.DataSource = osoby;
            }
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            if (osoby.Count == 0)
            {
                MessageBox.Show("Brak DANYCH!!!", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);

            }
            else
            {

                klasycznie();
                if (MessageBox.Show("Obliczyc LAMBDA?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    lambda();
                }
                else
                {
                    tbLambda.Text = "Zrezygnowano z Lambdy";
                }
            }
        }

        private void lambda()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Minimalny wiek: " + osoby.Min(x=>x.Wiek));
            sb.AppendLine("Maksymalny wiek: " + osoby.Max(x=>x.Wiek));
            sb.AppendLine("Sredni wiek: " + osoby.Average(x=>x.Wiek));
            sb.AppendLine("==============================");
            osoby.GroupBy(x=>x.Imie).ToList().ForEach(x=> sb.AppendLine(x.Key + ": " + x.Count()));
            tbLambda.Text = sb.ToString();
        }

        private void klasycznie()
        {
            Dictionary<string, int> imieCount = new Dictionary<string, int>();
            int min =-1, max = -1;
            decimal suma = 0;
            // eszystko w jednej petli
            foreach (var o in osoby)
            {
                if (o.Wiek < min) min = o.Wiek;
                if (o.Wiek > max) max = o.Wiek;
                suma += o.Wiek;
                if (imieCount.ContainsKey(o.Imie)) imieCount[o.Imie]++;
                else imieCount.Add(o.Imie, 1);
            }
           /* tbKlasycznie.Clear();
            tbKlasycznie.AppendText("Minimalny wiek: " + min);
            tbKlasycznie.AppendText("Maksymalny wiek: " + max);
            tbKlasycznie.AppendText("Sredni wiek: " + suma/osoby.Count);
            tbKlasycznie.AppendText("==============================");
            foreach (var a in imieCount)
            {
                tbKlasycznie.AppendText(a.Key + ": " + a.Value);
            }
            */
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Minimalny wiek: " + min); 
            sb.AppendLine("Maksymalny wiek: " + max);
            sb.AppendLine("Sredni wiek: " + suma / osoby.Count);
            sb.AppendLine("==============================");
            foreach (var a in imieCount)
            {
                sb.AppendLine(a.Key + ": " + a.Value);
            }
            tbKlasycznie.Text = sb.ToString();
                 


        }
    }
}
