﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Temperatura
{
    class Program
    {
        /*
         W pliku temperatura.csv zapisany jest log temperatury z jednej godziny. W zadaniu nalezy obliczyc
         * srednia
         * min
         * max
         * ilosc pomiarow powyzej temperatury krytycznej
         * Nalezy zastosowac podejscie klasyczne i lambda
         * 
         * Popraw ewentualne bledy oraz zabezpiecz kod konstrukcja try/catch/finally
         * Uzupelnij kod w podanych miejscach
         
         */
        static void Main(string[] args)
        {
            const int temperatureAlarm = 90;
            List<int> temperatureList = new List<int>();
            // Uzupelnij kod tak, aby wyswietlic nr linii, gdzie wystapi blad parsowania
            using (TextReader rd = new StreamReader("temperatura.csv"))
            {
                string line;
                rd.ReadLine(); // skip first line
                while((line=rd.ReadLine()) != null)
                {
                    // tu zliczaj przetworzone linie
                    string [] parts = line.Split(';');
                    int temperatureVal = 0;
                    if(parts.Count() > 2)
                    {
                        try
                        {
                            temperatureVal = int.Parse(parts[2]);
                        }
                        catch (FormatException ex)
                        {
                            Console.WriteLine("Blad w linii .... : " + ex.Message );                            
                        }
                       // int.TryParse(parts[0], out temperatureVal);
                        // if(!int.TryParse(parts[0], out temperatureVal)) Console.WriteLine("Blad w linii ....")
                        temperatureList.Add( temperatureVal);
                    }
                }
            }
            // Srednia, min, max, ilosc powyzej temperatury krytycznej
            // Kod klasyczny
            Console.WriteLine("Kod \"klasyczny\"");
            decimal suma = 0;
            foreach (int a in temperatureList)
            {
                suma += a;
            }
            Console.WriteLine("Srednia: " + suma/temperatureList.Count);
            Console.WriteLine("Srednia: " + (suma / temperatureList.Count).ToString("N2"));
         
            int min, max, criticCount=0;
            min = max = temperatureList[0];
            // Wyszukujemy min, max i ilosc pomiarow powyzej temp. krytycznej w jednej petli for
            for (int i = 0; i < temperatureList.Count; i++)
            {
                int val = temperatureList[i];
                if(val < min) min = val;
                // ... tu wstaw wyrazenie wykrywajace max
                if(val >= temperatureAlarm) criticCount++;
            }
            Console.WriteLine("Minimum: " + min);
            Console.WriteLine("Maksimum: " + max);
            Console.WriteLine("Ilosc pomiarow powyzej temp. alarmowej: " + criticCount);
          
            //
            // Lambda
            //
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("Kod \"Lambda\"");

            //Console.WriteLine("Srednia: " + (temperatureList.Average(x => x)).ToString("N2"));
            Console.WriteLine("Srednia: " + (temperatureList.Average()).ToString("N2")); // dla skalara można pominac zapis a=>a           
            Console.WriteLine("Minimum: " + temperatureList.Min());
            Console.WriteLine("Maksimum: tu wyswietl maximum" );
            Console.WriteLine("Ilosc pomiarow powyzej temp. alarmowej: " + temperatureList.Count(x=>x >= temperatureAlarm));
            
            // 
            //Tuple<int, int> t = new Tuple<int, int>(1,1); przyklad
            List<Tuple<DateTime, int>> listTuple = new List<Tuple<DateTime, int>>();
            using (TextReader rd = new StreamReader("temperatura.csv"))
            {
                string line;
                rd.ReadLine(); // skip first line
                while ((line = rd.ReadLine()) != null)
                {
                    // tu zliczaj przetworzone linie
                    string[] parts = line.Split(';');
                    int temperatureVal = 0;
                    if (parts.Count() > 2)
                    {
                        DateTime dt = new DateTime(
                            DateTime.Now.Year,
                            DateTime.Now.Month,
                            DateTime.Now.Day,
                            int.Parse(parts[0]), // hour
                            int.Parse(parts[1]), // minute
                            0);
                        int.TryParse(parts[2], out temperatureVal);
                        listTuple.Add(Tuple.Create(dt,temperatureVal));
                    }
                }
            }

            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("Tuple, kod \"Lambda\"");

            //Console.WriteLine("Srednia: " + (temperatureList.Average(x => x)).ToString("N2"));
            Console.WriteLine("Srednia: " + (listTuple.Average(a=>a.Item2)).ToString("N2")); // dla skalara można pominac zapis a=>a           
            var toupleMin = listTuple.FirstOrDefault(a=> a.Item2 == listTuple.Min(x=>x.Item2));
            Console.WriteLine("Minimum: " + toupleMin.Item2 + ", godz.: " + toupleMin.Item1.ToLongTimeString());
            Console.WriteLine("Minimum: " + toupleMin.Item2 + ", godz.: " + toupleMin.Item1.ToString("yyyy-MM-dd hh:mm"));
            //var toupleMax = 
         
            Console.WriteLine("Maksimum: tu wyswietl maximum analogicznie do minimum");
            Console.WriteLine("Ilosc pomiarow powyzej temp. alarmowej: " + temperatureList.Count(x => x >= temperatureAlarm));
            

            Console.ReadKey();
        }
    }
}
